// $Id: lin_serial.h,v 1.5 2003/12/16 21:19:31 rwuest Exp $
/*
    SPGMR08 68HC08GP32 Loader
    Copyright (C) 2001  Sirius Engineering Company

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2.
    See the file COPYING that is distributed with this program.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#ifndef LIN_SERIAL_H
#define LIN_SERIAL_H

extern int dbgser;		// flag turns debug output on/off

int rts_on(int fd);
int rts_off(int fd);
int dtr_on(int fd);
int dtr_off(int fd);
int serial_open(char *);
int serial_close(int);
int serial_reopen( int ofd, char *portname );
int serial_write( int fd, char *buf, int count);
int serial_read( int fd, char *buf, int count);
void serial_iflush(int fd);
int serial_owait(int fd);
int serial_status(int fd);
//int serial_baud( int fd, int baudrate);
int serial_setspeed( int fd, int rate);
#endif /* LIN_SERIAL_H */

// $Log: lin_serial.h,v $
// Revision 1.5  2003/12/16 21:19:31  rwuest
// changed unsigned chars to chars
//
// Revision 1.4  2001/08/17 11:54:43  rwuest
// Modify license to eliminate the "any later version clause"
// If a later version comes out, and I want to use it,
// I'll change the license then.
//
// Revision 1.3  2001/08/04 17:00:23  rwuest
// Add baudrate changing int serial_setspeed()
//
// Revision 1.2  2001/07/22 00:37:08  rwuest
// New file with print functions
// Debug messages now all print through dprint()
// Standard out now all goes througn xprint()
// Error messages all go through eprint()
//

