// $Id: mongp32.h,v 1.6 2003/12/16 21:19:31 rwuest Exp $
/*
    SPGMR08 68HC08GP32 Loader
    gp32 monitor functions
    Copyright (C) 2000  Robert Wuest (rwuest@wuest.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2.
    See the file COPYING that is distributed with this program.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#ifndef MONGP32_H
#define MONGP32_H

extern int dbgmon;		// flag turns debug output on/off

struct HC08stack {
	unsigned int sp;
	char a,x,cc,h;
	unsigned int pc;
};


/* The basic ops supported in the Monitor program */
int mon_read(int fd, char *buf, int address);
int mon_iread(int fd, char *buf);
int mon_write(int fd, char *buf, int address);
int mon_iwrite(int fd, char *buf);
int mon_readsp(int fd, char *buf);
int mon_run(int fd);


/* helpers */
int mon_reset(int fd);
int mon_blkread(int fd, char *buf, int address, int count);
int mon_blkwrite(int fd, char *buf, int address, int count);
int mon_write_scode( int fd, int which );
int mon_read_stack( int fd, struct HC08stack *stack);
int mon_show_stack( int fd, struct HC08stack *stack);
int mon_runpc(int fd, unsigned int pc);
int mon_runstack(int fd, struct HC08stack *);
int mon_read_ax( int fd, struct HC08stack *stack);
int mon_write_file(char *filename);
int mon_write_file_range(char *filename, unsigned int dest, unsigned int start, unsigned int count);

#endif /* MONGP32_H */

// $Log: mongp32.h,v $
// Revision 1.6  2003/12/16 21:19:31  rwuest
// changed unsigned chars to chars
//
// Revision 1.5  2001/08/17 11:54:42  rwuest
// Modify license to eliminate the "any later version clause"
// If a later version comes out, and I want to use it,
// I'll change the license then.
//
// Revision 1.4  2001/08/04 17:20:38  rwuest
// removed mon_check40()
//
// Revision 1.3  2001/07/26 21:07:50  rwuest
// Added defienitions for struct HC08stack, int mon_read_stack()
// int mon_show_stack(), int mon_runpc(), int mon_runstack(),
// int mon_read_ax(), int mon_write_file(), and int mon_write_file_range()
// Changed interface to int mon_write_scode() to use an index
// into the global sec_codes array.
//
// Revision 1.2  2001/07/22 00:37:08  rwuest
// New file with print functions
// Debug messages now all print through dprint()
// Standard out now all goes througn xprint()
// Error messages all go through eprint()
//

