// $Id: ops.h,v 1.3 2003/12/16 21:47:56 rwuest Exp $
/*
	SPGMR08 68HC08GP32 Loader
	generic interface to cpu ops
	Copyright (C) 2001  Sirius Engineering Company

	This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2.
    See the file COPYING that is distributed with this program.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
*/


#ifndef OPS_H
#define OPS_H



typedef struct target_operations CPU;

struct target_operations {
	char *cpu_name;
	int	(*erase_function) (CPU *);
	int (*flash_function)( CPU *, char *);
	int (*verify_function)( CPU *,char *);
	int (*eeprom_function)( CPU *,char *);
	int (*reset_function)(CPU *, int );
	int (*run_function)(CPU *, int);
	int (*read_function)(CPU *);
	int (*write_function)(CPU *);
	char *eeprom_module;
	char *verify_module;
	char *program_module;
	char *erase_module;
	char *loaded_module;
	void *cpu_data;		// anything the cpu driver wants to put here
};


// ops.c
// these are the main externally accessed functions, ie. used in cli.g
CPU *cpu_open( char *name );
int cpu_close(CPU *);
int ops_init(void);
int mass_erase(CPU *);
int program_flash(CPU *, char *filename);
int verify_flash(CPU *, char *filename);
const char *cpu_name( CPU *xcpu );
int reset_cpu( CPU *xcpu, int which );


char *processor_module(char *);

int load_module(CPU *xcpu, char *mod);



// ops_gp32.c
int mass_erase_gp32(CPU *);
int program_flash_gp32(CPU *,char *filename);	
int verify_flash_gp32(CPU *,char *filename);	
CPU *gp32_init(struct target_operations *);
int reset_gp32(CPU * xcpu, int which);
int run_gp32(CPU *xcpu, int pc);

CPU *ab32_init(struct target_operations *);
int reset_ab32(CPU * xcpu, int which);


// jb8_driver.c
CPU *jb8_init(CPU *xcpu);



#endif
