// $Id: rcfile.c,v 1.5 2003/12/16 21:24:06 rwuest Exp $
/*
    SPGMR08 68HC08GP32 Loader
	handles rc files
    Copyright (C) 2000  Robert Wuest (rwuest@wuest.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2.
    See the file COPYING that is distributed with this program.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#include <stdio.h>
#include <stdlib.h>

#include "spgmr.h"
#include "seccodes.h"
#include "rcfile.h"

/* Storage for rcfile is in a linked list of char*'s */
struct rc_memory {
	char *line;
	struct rc_memory *next;
};

#define MAXLINE 1024

/****************************************************************************/
/*                 rc_memory *rc_read(char *fname)                          */
/*                                                                          */
/* Read an rcfile into new rc-memory                                        */
/* Return struct rc_memory * on success, NULL on failure                    */
/****************************************************************************/
struct rc_memory * rc_read(char *fname)
{
	FILE *f;
	struct rc_memory *rmbase,*rmnext;
	char buf[MAXLINE];

	if (!fname ) return NULL;
	if ( (f=fopen(fname, "r")) == NULL ) {
		perror("rcfile open failed");
		return NULL;
	}

	rmbase = (struct rc_memory *)malloc( sizeof(struct rc_memory));
	if (!rmbase) {
		perror("rcfile memory error");
		fclose(f);
		return NULL;
	}

	// read it all into memory
	while ( fgets(buf, MAXLINE, f ) != NULL ) {

	}



	return 0;
}

/****************************************************************************/
/*                 int rc_write(char *fname, struct rc_memory *base)        */
/*                                                                          */
/* Write rc_memory out an rcfile fname                                      */
/* Return 0 on success, -1 on failure                                       */
/****************************************************************************/
int rc_write(char *fname, struct rc_memory *base)
{
	return 0;
}
