// $Id: s1utils.h,v 1.5 2003/12/16 21:23:33 rwuest Exp $
/*
    SPGMR08 68HC08GP32 Loader
    Copyright 1988-2001, Sirius Engineering Company
    Copyright 1995-1997 Kemet Electronics Corporation
    Permission to reuse is granted, but the copyright message
    must stay intact.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2.
    See the file COPYING that is distributed with this program.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#ifndef S1UTILS_H		// avoid multiple includes
#define S1UTILS_H

#ifndef _STDIO_H
#include <stdio.h>
#endif

// some generic defs
#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifdef __TURBOC__
#define HUGE huge
#else
#define HUGE
#endif

// s1decodeline return values

#define S1_BAD_FORMAT -1
#define S1_NO_DATA -2
#define S1_BAD_BUFFER -3
#define S1_BAD_CHECKSUM -4

// line checksum processing values
// normal (full) line checksum error checking
enum lcsmode
{ LCS_NORMAL = 0, LCS_IGNORE };

// Maximum number of data bytes from an S1 line
#define MAXS1BYTES 32
// Maximum number of data bytes to an S1 line
#define MAXS1WBYTES 16
// Maximum length of a line from an S19 file
#define MAXS1LINE 256
// Maximum data read by fillbuffer
#define MAXS1DATA 256

struct s1_ls
{
  char *s1line;
  unsigned char *data;
  int type;
  unsigned long address;
  int s1len;
  unsigned int checksum;
  int flags;
};



// functions in S1UTILS.CPP
unsigned int gethex(char *(*sp),int n);

int fprints0 (FILE * f, char *message);
int fprints9 (FILE * f, unsigned int entry_address);
unsigned long fprints1 (FILE * f,
		     char *data,
		     unsigned long start_add, unsigned long len);
char *gets0header (char *s0buffer);	// copies header into buffer and
									// return buffer;
									// destroys the buffers 'S0' format
unsigned int gethex (char *(*sp), int n);

int s1decodeLine (char *line, unsigned char *databuffer,
		  unsigned long *line_address, int *s1len,
		  enum lcsmode checksum_mode);
int s1decode (struct s1_ls *s1l);

int s1ffillBuffer (FILE * f,	/* where to get the data */
		    char *databuffer,	/* where to put data */
		    unsigned long *line_address,	/* return start address here */
		    int *s1_len,	/* return actual databuffer byte count here */
		    enum lcsmode checksum_mode);

int s1fsearchBLk(FILE *f, char *dest, \
				 unsigned long first, unsigned long last);

#endif /* S1UTILS_H */

// $Log: s1utils.h,v $
// Revision 1.5  2003/12/16 21:23:33  rwuest
// changed unsigned chars to chars
//
// Revision 1.4  2001/08/17 11:54:43  rwuest
// Modify license to eliminate the "any later version clause"
// If a later version comes out, and I want to use it,
// I'll change the license then.
//
// Revision 1.3  2001/07/26 20:58:48  rwuest
// renamed just about everything. After ten years, you'd think I had names I liked here.
//
// Revision 1.2  2001/07/22 00:37:08  rwuest
// Added Log at end
//

