// $Id: seccodes.h,v 1.6 2003/12/16 21:22:46 rwuest Exp $
/*
    SPGMR08 68HC08GP32 Loader
	handles for security codes
    Copyright (C) 2000  Robert Wuest (rwuest@wuest.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2.
    See the file COPYING that is distributed with this program.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/


#ifndef SECCODES_H
#define SECCODES_H

#include <stdio.h>
#define SECCFILE ".spgmr08rc"	// default security codes file name

#define SECCSIZE 8
#define SECCMAX 10

extern unsigned char sec_codes[SECCMAX][SECCSIZE];
extern unsigned char xcodes[SECCSIZE];

#define XCODES -1

//typedef unsigned char sc[SECCSIZE];

int scodes_init(void);
int scodes_close(void);

int scodes_find_s1(FILE *, int which, char *buf);
int scodes_set( char *codes, int which);	
int scodes_get( char *codes, int which );
void scodes_push( char *codes );
int scodes_print( int which );



#endif /* SECCODES_H */

// $Log: seccodes.h,v $
// Revision 1.6  2003/12/16 21:22:46  rwuest
// changed unsigned chars to chars
//
// Revision 1.5  2001/08/17 11:54:42  rwuest
// Modify license to eliminate the "any later version clause"
// If a later version comes out, and I want to use it,
// I'll change the license then.
//
// Revision 1.4  2001/08/04 17:17:55  rwuest
// major rewrite
//
// Revision 1.3  2001/07/26 21:03:21  rwuest
// changed find_s1_scodes()'s pointer arg to an index into the
// global sec_codes[][] array.
//
// Revision 1.2  2001/07/22 00:37:08  rwuest
// New file with print functions
// Debug messages now all print through dprint()
// Standard out now all goes througn xprint()
// Error messages all go through eprint()
//

