// $Id: spgmr.h,v 1.9 2003/12/16 21:19:31 rwuest Exp $
/*
    SPGMR08 68HC08GP32 Loader
    Copyright (C) 2000  Robert Wuest (rwuest@wuest.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2.
    See the file COPYING that is distributed with this program.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#ifndef SPGMR_H
#define SPGMR_H


// args.c
int process_args(int argc, char *argv[]);
void prusage();
extern int verbose;
extern int progress;
extern char *exename;
extern int debug;
extern int noprompt;
extern int pflag;
extern FILE *pfile;
extern char *pfilename;
extern int rflag;
extern FILE *rfile;
extern char *rfilename;
extern int Sflag;
extern FILE *Sfile;
extern char *Sfilename;
extern int Cflag;
extern FILE *Cfile;
extern char *Cfilename;
extern int eflag;
extern int interactive;
extern int Rflag;
extern char *runaddress;
extern char *aspec[10];
extern int acnt;
extern FILE *logfile;
extern char *logfilename;
extern char *portname;
extern FILE *infile, *outfile, *errfile, *dbgfile;
extern char *infilename, *outfilename, *errfilename;
extern int signum;
extern char *cpuname;
extern int baud_rate;

// utils.c
int xprint(const char *fmt, ...);	// to outfile
int eprint(const char *fmt, ...);	// to errfile, maybe log
int wprint(const char *fmt, ...);	// warning message to errfile
int dprint(const char *fmt, ...);	// debug output
void format_dump(char *buf, int base, int len);
void statinfo(int fd );
char *ltrim(char *s);
char *rtrim(char *s);
char *trim(char *s);


// main.c
void eexit(int);
void iexit(int);

extern int sfd;	// serial port in use



#endif /* SPGMR_H */

// $Log: spgmr.h,v $
// Revision 1.9  2003/12/16 21:19:31  rwuest
// changed unsigned chars to chars
//
// Revision 1.8  2001/08/17 11:54:43  rwuest
// Modify license to eliminate the "any later version clause"
// If a later version comes out, and I want to use it,
// I'll change the license then.
//
// Revision 1.7  2001/08/11 14:37:18  rwuest
// Add baudrate  global int
//
// Revision 1.6  2001/08/04 17:04:14  rwuest
// moved format_dump to utils
// added dbgfile for debug output
// added wprint() for warnings
// removed ops_gp32 stuff
//
// Revision 1.5  2001/07/29 03:33:34  rwuest
// added int signum from command line --signal
// added void set_scodes(char *codes, int which); in utils
//
// Revision 1.4  2001/07/27 16:46:58  rwuest
// dprint is now it's own function
//
// Revision 1.3  2001/07/26 20:52:04  rwuest
// Added trim functions in utils.c
// added file ops_gp32.c and its global functions
//
// Revision 1.2  2001/07/22 00:37:08  rwuest
// New file with print functions
// Debug messages now all print through dprint()
// Standard out now all goes througn xprint()
// Error messages all go through eprint()
//

