#ifndef TIMEC_H
#define TIMEC_H

#ifndef _SYS_TIME_H
#include <sys/time.h>
#endif

// time structure conversions
// timeval to double
static inline double tvtod( struct timeval *t )
{
	return (double)t->tv_sec + (double)t->tv_usec/(double)1000000.0;
}

// double to timeval
static inline void dtotv( struct timeval *t, double v )
{
	int wp = (int)v;	// truncatate fractional part
	int fp = (int)((v-wp)*1000000);
	t->tv_sec = wp;		
	t->tv_usec = fp;
}

// t1-t2 as a double
static inline double diff_timeval( struct timeval *t1, struct timeval *t2 )
{
	return tvtod( t1 ) - tvtod( t2 );
}

#endif
