#!/bin/sh
# the next line restarts using wish\
exec wishx "$0" "$@"
if {![info exist vTcl(sourcing)]} {

}
############################
# code to load stock images


if {![info exist vTcl(sourcing)]} {
proc vTcl:rename {name} {

    regsub -all "\\." $name "_" ret
    regsub -all "\\-" $ret "_" ret
    regsub -all " " $ret "_" ret
    regsub -all "/" $ret "__" ret

    return [string tolower $ret]
}

proc vTcl:image:create_new_image {filename description type} {

	global vTcl env

	# image already existing ?
	if [info exists vTcl(images,files)] {

		set index [lsearch -exact $vTcl(images,files) $filename]

		if {$index != "-1"} {
			# cool, no more work to do
			return
		}
	}

	# wait a minute... does the file actually exist?
	if {! [file exists $filename] } {

		# try current directory
		set script [file dirname [info script]]
		set filename [file join $script [file tail $filename] ]

		# puts "looking for $filename..."
	}

	if {! [file exists $filename] } {

		set description "file not found!"

		set object [image create bitmap -data {
		    #define open_width 16
		    #define open_height 16
		    static char open_bits[] = {
			0x7F, 0xFE,
			0x41, 0x82,
			0x21, 0x81,
			0x41, 0x82,
			0x21, 0x81,
			0x21, 0x81,
			0x21, 0x81,
			0x91, 0x80,
			0x21, 0x81,
			0x91, 0x80,
			0x21, 0x81,
			0x21, 0x81,
			0x21, 0x81,
			0x41, 0x82,
			0x41, 0x82,
			0x7F, 0xFE};}]

	} else {

		set object [image create  [vTcl:image:get_creation_type $filename]  -file $filename]
	}

	set reference [vTcl:rename $filename]

	set vTcl(images,$reference,image)       $object
	set vTcl(images,$reference,description) $description
	set vTcl(images,$reference,type)        $type
	set vTcl(images,filename,$object)       $filename

	lappend vTcl(images,files) $filename

	# return image name in case caller might want it
	return $object
}

proc vTcl:image:get_image {filename} {

	global vTcl
	set reference [vTcl:rename $filename]

	# let's do some checking first
	if {! [info exists vTcl(images,$reference,image)] } {

		# well, the path may be wrong; in that case check
		# only the filename instead, without the path

		set imageTail [file tail $filename]

		foreach oneFile $vTcl(images,files) {

			if { [file tail $oneFile] == $imageTail } {

				set reference [vTcl:rename $oneFile]
				break
			}
		}
	}

	return $vTcl(images,$reference,image)
}

proc vTcl:image:get_creation_type {filename} {

	set ext [file extension $filename]
	set ext [string tolower $ext]

	switch $ext {

		.ppm -
		.gif    {return photo}
		.xbm    {return bitmap}

		default {return photo}
	}
}

vTcl:image:create_new_image "/usr/local/lib/vtcl-1.2.2/images/edit/copy.gif" \
    "" \
    "stock"
vTcl:image:create_new_image "/usr/local/lib/vtcl-1.2.2/images/edit/cut.gif" \
    "" \
    "stock"
vTcl:image:create_new_image "/usr/local/lib/vtcl-1.2.2/images/edit/paste.gif" \
    "" \
    "stock"
vTcl:image:create_new_image "/usr/local/lib/vtcl-1.2.2/images/edit/new.gif" \
    "" \
    "stock"
vTcl:image:create_new_image "/usr/local/lib/vtcl-1.2.2/images/edit/open.gif" \
    "" \
    "stock"
vTcl:image:create_new_image "/usr/local/lib/vtcl-1.2.2/images/edit/save.gif" \
    "" \
    "stock"
vTcl:image:create_new_image "/usr/local/lib/vtcl-1.2.2/images/edit/replace.gif" \
    "" \
    "stock"
}
############################
# code to load user images

############################
# code to load stock fonts


if {![info exist vTcl(sourcing)]} {
set vTcl(fonts,counter) 0
proc vTcl:font:add_font {font_descr font_type newkey} {

     global vTcl

     incr vTcl(fonts,counter)
     set newfont [eval font create $font_descr]

     lappend vTcl(fonts,objects) $newfont

     # each font has its unique key so that when a project is
     # reloaded, the key is used to find the font description

     if {$newkey == ""} {
          set newkey vTcl:font$vTcl(fonts,counter)
     }

     set vTcl(fonts,$newfont,type)                      $font_type
     set vTcl(fonts,$newfont,key)                       $newkey
     set vTcl(fonts,$vTcl(fonts,$newfont,key),object)   $newfont

     # in case caller needs it
     return $newfont
}

proc vTcl:font:get_font {key} {

	global vTcl

	return $vTcl(fonts,$key,object)
}

vTcl:font:add_font \
    "-family helvetica -size 12 -weight normal -slant roman -underline 0 -overstrike 0" \
    stock \
    vTcl:font1
vTcl:font:add_font \
    "-family helvetica -size 12 -weight normal -slant roman -underline 1 -overstrike 0" \
    stock \
    underline
vTcl:font:add_font \
    "-family courier -size 12 -weight normal -slant roman -underline 0 -overstrike 0" \
    stock \
    vTcl:font3
vTcl:font:add_font \
    "-family times -size 12 -weight normal -slant roman -underline 0 -overstrike 0" \
    stock \
    vTcl:font4
vTcl:font:add_font \
    "-family helvetica -size 12 -weight bold -slant roman -underline 0 -overstrike 0" \
    stock \
    vTcl:font5
vTcl:font:add_font \
    "-family courier -size 12 -weight bold -slant roman -underline 0 -overstrike 0" \
    stock \
    vTcl:font6
vTcl:font:add_font \
    "-family times -size 12 -weight bold -slant roman -underline 0 -overstrike 0" \
    stock \
    vTcl:font7
vTcl:font:add_font \
    "-family lucida -size 18 -weight normal -slant roman -underline 0 -overstrike 0" \
    stock \
    vTcl:font8
vTcl:font:add_font \
    "-family lucida -size 18 -weight normal -slant italic -underline 0 -overstrike 0" \
    stock \
    vTcl:font9
}
############################
# code to load user fonts

vTcl:font:add_font \
    "-family fixed -size 10 -weight normal -slant roman -underline 0 -overstrike 0" \
    user \
    vTcl:font10
#############################################################################
# Visual Tcl v1.22 Project
#

#################################
# GLOBAL VARIABLES
#
global cpu;
global erase_sure;
global port;
global pr;
global pr1;
global pr2;
global program_sure;
global pw;
global pw1;
global pw2;
global r_timeout;
global read_filename;
global reset_sure;
global runaddress;
global s_timeout;
global scodes_filename;
global selectedCPU;
global selectedPort;
global spgmr;
global spgmr_active;
global spgmr_busy;
global srec_filename;
global widget;
    set widget(.vTcl.fontmgr.listbox) {.vTcl.fontmgr.fra28.cpd29.01}
    set widget(.vTcl.fontmgr.text) {.vTcl.fontmgr.cpd43.03}
    set widget(but_start) {.top17.fra34.04.09.010.012}
    set widget(but_stop) {.top17.fra34.04.09.010.013}
    set widget(dlg_about_server) {.top20}
    set widget(dlg_cfg_gp32) {.top18}
    set widget(dlg_debugTkspgmr) {.top29}
    set widget(dlg_readdata) {.top24}
    set widget(dlg_selcpu) {.top19}
    set widget(dlg_spgmr) {.top17}
    set widget(ent_read_filename) {.top24.fra25.05.fra31.fra27.fra33.01}
    set widget(ent_srec_filename) {.top17.fra34.04.09.fra30.01}
    set widget(rev,.top17) {dlg_spgmr}
    set widget(rev,.top17.fra34.04.05.08) {x_text}
    set widget(rev,.top17.fra34.04.09.010.012) {but_start}
    set widget(rev,.top17.fra34.04.09.010.013) {but_stop}
    set widget(rev,.top17.fra34.04.09.fra30.01) {ent_srec_filename}
    set widget(rev,.top18) {dlg_cfg_gp32}
    set widget(rev,.top19) {dlg_selcpu}
    set widget(rev,.top20) {dlg_about_server}
    set widget(rev,.top20.fra21.fra22.tex26) {x_about_server}
    set widget(rev,.top24) {dlg_readdata}
    set widget(rev,.top24.fra25.01.04) {x_data}
    set widget(rev,.top24.fra25.05.fra31.fra27.fra33.01) {ent_read_filename}
    set widget(rev,.top29) {dlg_debugTkspgrm}
    set widget(rev,.vTcl.fontmgr.cpd43.03) {.vTcl.fontmgr.text}
    set widget(rev,.vTcl.fontmgr.fra28.cpd29.01) {.vTcl.fontmgr.listbox}
    set widget(x_about_server) {.top20.fra21.fra22.tex26}
    set widget(x_data) {.top24.fra25.01.04}
    set widget(x_text) {.top17.fra34.04.05.08}
global x_command;
global xdest;
global xpid;

#################################
# USER DEFINED PROCEDURES
#

proc {alarm_handler} {{arg run}} {
global s_timeout;

    if { $s_timeout > 0 } {
        set s_timeout [expr $s_timeout-1]
    }
    if { $s_timeout < 0 } {
        set s_timeout 0
    }


    switch "$arg" {
        off { signal ignore SIGALRM }
        on  { signal -restart trap SIGALRM { alarm_handler } ; alarm 0.1 }
        run { alarm 0.1 }
    }
}

proc {cvslogs} {} {
#this is a dummy to hold cvs log messages
# $Id: tkspgmr.tcl,v 1.11 2003/12/16 21:26:35 rwuest Exp $
# $Log: tkspgmr.tcl,v $
# Revision 1.11  2003/12/16 21:26:35  rwuest
# use wishx interpretor
#
# Revision 1.10  2001/08/17 11:54:42  rwuest
# Modify license to eliminate the "any later version clause"
# If a later version comes out, and I want to use it,
# I'll change the license then.
#
# Revision 1.9  2001/08/11 14:46:02  rwuest
# added serial port setting to cpu select
# added globals port and selectedPort
# reset debug flags on server stop
# added server stop and start to sever dropdown on main
# moved debug server to server dropdown
# cmdline in debug dialog exec's a tcl command with output to x_text
# added cpu and port displays on main dialog
#
# Revision 1.8  2001/08/04 17:14:32  rwuest
# Major rewrite
# added d_xxx for all cpu operations
# set cpu in spgmr:start
# don't print bad files in fileinfo
# fixed get_filename{} - now takes, and uses, a default file type
# SIGUSR2 tries to recover from a lost server
# lots of new flags: spgmr_active, spgmr_busy
#    sure_xxxx for some operations
# added support for multiple cpus
# lots of security code handling additions
# flipped main window to better set on left of screen
#
# Revision 1.7  2001/07/29 04:13:00  rwuest
# fixed xdest global in mainline and init
#
# Revision 1.6  2001/07/29 03:48:43  rwuest
# renamed all the spgmr procs to spgmr:something.
# added r_timeout, reloads s_timeout after some data is received. This
# way you only need to gues hoolong the operation takes before it returns
# data. not how long the transfer ill take, too.
# added enter_cmd to process commands in entry widgets for the server
# file reading now uses a fileevent loop. Much beeter, ahhhh!
# added an spgmr_busy global, set after the start and until the
# completion of a server command
# added spgm_active global. sert when the server is running.
# added an abort button to the main window
# relaid out the data control wigets to let the output arear resize
# better.
# close unused files in parent and child (after fork) when starting
# server.
# moved pipe creation to spgmr:start. reloading in vtcl was leaving lots
# of open files around.
# redid the dlg_debug debug buttons.  They're now really radiobuttons.
# Added I'm sure radio buttons next to erase reset and program button in
# main window
#
# Revision 1.5  2001/07/27 16:49:38  rwuest
# added read data and debug spgmr dialogs
# redo main right side
# added timeout with SIGALRM
#
# Revision 1.4  2001/07/22 02:21:35  rwuest
# Don't try to read if no server active
#
# Revision 1.3  2001/07/22 01:17:40  rwuest
# sync to prompt after starting server
# stop server and close pipes correctly on exit
#
# Revision 1.2  2001/07/22 01:07:53  rwuest
# Added global pipe variables pr rp1 pr2 pw pw1 pw2 - communication to
# spgmr is through pr and pw, set in start_spgmr, created in main.
# Added fileinfo to print pipe data and run fileinfo in the server
# Added open_spgmr to dup the pipes, fork and exec the server
# Added read_spgmr to loop, copying lines to output widget, until it gets a prompt.
# Handle lots of signals
# Added stop_spgmr to SIGTERM the server
# Aadded write_spgmr to send messages to the server
# xexit closes pipes
# Added several buttons useful for debugging.
# Added a cvslogs function to hold these checkin log messages and the Id
#
}

proc {do_erase} {flag} {
global widget
global s_timeout r_timeout;

if { $flag } {
    set s_timeout 150; # 15 secs to timeout
    set r_timeout 10;
    spgmr:write "erase"
    set s_timeout 0
}
}

proc {do_program} {flag} {
global widget
global srec_filename
global s_timeout r_timeout

if { $flag && ($srec_filename != "") } {
    set s_timeout 150; # 7 minutes to timeout
    set r_timeout 10;
    spgmr:write  "program from $srec_filename"
    set s_timeout 0
}
}

proc {do_reset} {flag {which 0}} {
global widget
global s_timeout r_timeout

if { $flag } {
    set s_timeout 10; # 1 sec to timeout
    set r_timeout 10;
    spgmr:write "scodes try $which"
    set s_timeout 0
}
}

proc {do_verify} {} {
global widget
global srec_filename
global s_timeout r_timeout

if { $srec_filename != "" } {
    set s_timeout 150; # 15 secs to timeout
    set r_timeout 10;
    spgmr:write "verify from $srec_filename"
    set s_timeout 0
}
}

proc {enter_cmd} {path} {
global widget

    set cmd [$path get]
    $path delete 0 end;
    spgmr:write $cmd
}

proc {fileinfo} {} {
global widget
    global pr pw pr1 pw1 pr2 pw2

    # get info

    catch {fstat $pr ino} pr_i
    catch {fstat $pr size} pr_s

    catch {fstat $pw ino} pw_i
    catch {fstat $pw size} pw_s

    xputs "pr: $pr, pw: $pw"
    xputs "pr: $pr\ninode: $pr_i size: $pr_s"
    xputs "pw: $pw\ninode: $pw_i size: $pw_s"
}

proc {forkx} {in out cmd} {
if {[set child [fork]] == 0} {
        # in the child
        dup $in stdin
        close $in
        dup $out stdout
        close $out
        execl $cmd
        # never get here
    }

    return $child
}

proc {get_filename} {args} {
global widget
    global tk_strictMotif

    # usage: get_filename ?type? ?default?
    # type is one of any, s19, src, scr
    #
    #
    set argc [llength $args]
    set place 0
    set ftype any
    set fname ""
    set rname ""

    if { $argc > 1 } {
        set ftype [lindex $args $place]
        incr place
        set argc [expr $argc-1]
    }
#    set type [lindex $args $place]

    if { $argc > 1 } {
        set fname [lindex $args $place]
        incr place
        set argc [expr $argc-1]
    }



    set s19 {{S19 files}  {*.lx *.s19 *.hex} }
    set src {{Source files} {*.s *.asm *.c *.h}}
    set scr {{Script files} {*.sps}}
    set any {{All Files}  * }

    switch $ftype {
        s19 { set types "[list $s19] [list $src] [list $scr] [list $any]" }
        src { set types "[list $src] [list $s19] [list $scr] [list $any]" }
        scr { set types "[list $scr] [list $s19] [list $src] [list $any]" }
        any { set types "[list $any] [list $s19] [list $src] [list $scr]" }
    }



    set tk_strictMotif 0
    set tmp_filename [tk_getOpenFile -filetypes $types  -initialdir [pwd]  -initialfile $fname ]
    if {$tmp_filename != "" } {
        set rname $tmp_filename
        # now set for the appropriate window
        # set dir [file dirname $srec_filename]
        # cd $dir
    }


    return $rname
}

proc {get_read_filename} {} {
global widget
global read_filename
set t [get_filename s19 $read_filename]
if { $t != "" } {
    set read_filename $t
}
$widget(ent_read_filename) xview moveto 1
}

proc {get_scodes} {} {
global widget
global srec_filename

if { $srec_filename != "" } {
    set s_timeout 10; # 1 sec to timeout
    spgmr:write "scodes from $srec_filename"
    set s_timeout 0
}
}

proc {get_srec_filename} {} {
global widget
global srec_filename
set t [get_filename s19 $srec_filename]
if { $t != "" } {
    set srec_filename $t
}
$widget(ent_srec_filename) xview moveto 1
}

proc {signals} {} {
global widget
    global xpid
    global pr pw
    global spgmr_active
    # handle interesting signals
    # SIGTERM SIGINT SIGQUIT SIGPIPE SIGALRM SIGHUP SIGCHLD SIGUSR1 SIGUSR2
    #
    signal trap SIGTERM { xexit; }

    signal trap SIGINT { xputs x_text "SIGINT" }

    signal trap SIGQUIT { xexit }

    signal -restart trap SIGPIPE { xputs x_text "SIGPIPE" }

    signal -restart trap SIGALRM { catch {alarm_handler} }
    # start the timer running
    alarm 0.1

    signal trap SIGHUP { spgmr:stop }

    signal -restart trap SIGCHLD {
            xputs x_text "SIGCHLD";
            set r [wait $xpid];
            if { [lindex $r 0] == $xpid } {
                set xpid -1;
                xputs x_text "Terminated."
                close $pr
                close $pw
                set spgmr_active 0
            }
        }

    signal -restart trap SIGUSR1 { xputs x_text "SIGUSR1" ; set s_timeout 0 }

    signal -restart trap SIGUSR2 {
            spgmr:abort
            spgmr:stop
            set spgmr_busy 0
            xputs x_text "SIGUSR2"
        }
}

proc {spgmr:abort} {} {
global widget
global xpid

if {$xpid != -1 } {
    kill SIGINT $xpid
}
}

proc {spgmr:read} {{arg {}}} {
global widget
    global pr
    global xpid
    global s_timeout
    global r_timeout
    global spgmr_busy




    # arg is widget alias to write respons to
    # usage: spgmr:read ?text_alias?
    set count 0
    set mytimeout 0
    if { $s_timeout == 0 } {
        set s_timeout 100 ;    # default to a 10 second timeout
        set r_timeout 10 ;     # and one second reload
        set mytimeout 1
    }
    set emsg ""
    catch {gets $pr} l
#    set l [gets $pr]
    set r $l

    if { ($l!="spgmr:") && ($s_timeout!=0) && ([catch {fblocked $pr}]!=1) } {
        if { [fblocked $pr] != 1 } {    # true when last read attempt succeeded
            regexp {error:(.*)?} $l s emsg
            if $r_timeout { set s_timeout $r_timeout }
            if { $arg == "" } {
                xputs "$l"
            } else {
                xputs $arg "$l"
            }
        }
        # set l [gets $pr]
        #append l $r
        set emsg ""
        update idletasks
    }
    if { $mytimeout == "1" } {
        set s_timeout 0;
    }
    if { $l=="spgmr:" } {
        set spgmr_busy 0;
    }
#    set spgmr_busy 0;
#    return "$r";
}

proc {spgmr:start} {} {
global spgmr
    global xpid
    global pr pw pr1 pw1 pr2 pw2
    global spgmr
    global spgmr_active
    global spgmr_busy
    global cpu
    global port

    if { $xpid == -1 } {
        pipe pr1 pw1;
        pipe pr2 pw2;
        xputs x_text [set xpid [forkx $pr2 $pw1 "$spgmr"]];
        set pr $pr1
        set pw $pw2
        close $pr2
        close $pw1

        fconfigure $pr -blocking off
        fileevent $pr readable spgmr:read
        set spgmr_active 1
        set spgmr_busy 0

        update
        spgmr:write x_text "cpu $cpu;serial port $port"
        update
#        spgmr:read
        #.top29.fra30.09.010.che27 select
        #.top29.fra30.09.010.che28 select
        #.top29.fra30.09.010.che29 select
    } else {
        xputs x_text "Already running."
    }
}

proc {spgmr:stop} {} {
global xpid
global che_dbg che_sdbg che_mdbg
    if { $xpid != -1 } {
        kill SIGTERM $xpid
        set che_dbg 0
        set che_sdbg 0
        set che_sdbg 0

    }
}

proc {spgmr:write} {args} {
global pw;
    global xpid;
    global spgmr_busy

    if { ($xpid!=-1) && ($spgmr_busy==0) } {
        set where x_text;    # default display widget
        set argc [llength $args]
        set place 0
        set text ""

        if { $argc > 1 } {
            set where [lindex $args $place]
            incr place
            set argc [expr $argc-1]
            set text [lindex $args $place]
        }

        if { $argc > 0 } {
            set text [lindex $args $place]
            set argc [expr $argc-1]
        }

        if { $argc > 0 } { programming error
            error "usage: spgmr:write ?text_alias? string"
        }

        if { "$text" == "" } {
            return;
        }

        xputs $where "--> $text"
        puts $pw "$text"
        flush $pw
        set spgmr_busy 1
        spgmr:read $where
    }
}

proc {x_clear} {arg} {
global widget
    $widget($arg) delete 0.0 end;
    $widget($arg) insert end "";
}

proc {xexit} {{v 0}} {
global widget;
    global pr pw pr1 pw1 pr2 pw2

    spgmr:stop
    signal ignore SIGALRM
    catch {close $pr1}
    catch {close $pw1}
    catch {close $pr2}
    catch {close $pw2}

    exit $v;
}

proc {xputs} {args} {
global widget;
global xdest

    set nl 1
    set where $xdest;    # default display widget
    set argc [llength $args]
    set place 0

    if { $argc > 1 } {
        if { [lindex $args 0] == "-nonewline" } {
            set nl 0
            incr place
            set argc [expr $argc-1]
        }
    }

    if { $argc > 1 } {
        if { [info exists widget([lindex $args $place])] } {
            set xdest [set where [lindex $args $place]]
            incr place
            set argc [expr $argc-1]
            set text [lindex $args $place]
        } else {
            error "bad widget [lindex $args $place]"
        }
    }

    if { $argc > 0 } {
        set text [lindex $args $place]
        set argc [expr $argc-1]
    }

    if { $argc > 0 } { # programming error
        error "usage: xputs ?-nonewline? ?dest_alias? string"
    }

    if [winfo exists $widget($where)] {
        $widget($where) insert end $text;
        if {$nl == "1" } {
            $widget($where) insert end "\n";
        }
        $widget($where) yview end;
        update idletasks
    }
}

proc {main} {argc argv} {
global widget
    global pr pw;
    global pr1 pw1;
    global pr2 pw2;
    global spgmr_busy
    global srec_filename
    global reset_sure erase_sure program_sure

    Window show $widget(dlg_spgmr)
    wm protocol $widget(dlg_spgmr)  WM_DELETE_WINDOW { xexit; }
    wm iconname $widget(dlg_spgmr) "tkspgmr"

    signals
    spgmr:start

    set reset_sure 1
    set erase_sure 1
    set program_sure 1


# from Steve Offutt
#% wm iconify .
#% bind all <Map> {puts "%W is mapped."}
#% pack [text .t]
#% wm deiconify .
#. is mapped.
#.t is mapped.
#    bind all <Map> { puts "%W is mapped"}
#    bind all <Property> { puts "%W is property"}
#    bind all <Circulate> { puts "%W circulate"}
#    bind all <Deactivate> { puts "%W deactivate"}
#    bind all <Configure> { puts "%W Configure"}
#    bind all <Unmap> { puts "%W is unmapped"}
set place 1
if {  [info exists vTcl] == 1 } {
    # in vtcl
    # Window show $widget(dlg_debug);
    set place 2

}

if { $argc > $place } {
    set place [expr $place-1]
    set srec_filename [lindex $argv $place]
}
}

proc {Window} {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
		raise   { if $exists {wm deiconify $newname; raise $newname; } }
    }
}

proc init {argc argv} {
global widget;
    global pr;
    global pw;
    global pr1;
    global pw1;
    global pr2;
    global pw2;
    global srec_filename;
    global read_filename;
    global scodes_filename;
    global s_timeout;
    global r_timeout;
    global spgmr;
    global xpid;
    global active;
    global spgmr_busy
    global spgmr_active
    global xdest
    global cpu
    global selectedCPU
    global port
    global selectedPort
    global runaddress

    set spgmr "spgmr"

    set xpid -1

    set pr -1
    set pw -1
    set pr1 -1
    set pw1 -1
    set pr2 -1
    set pw2 -1

    set s_timeout 0;
    set r_timeout 0;
    set srec_filename "";
    set read_filename "";
    set scodes_filename "";
    set spgmr_active 0;
    set spgmr_busy 0;
    set xdest x_text
    set cpu "gp32"
    set selectedCPU $cpu
    set port "/dev/ttyS1"
    set selectedPort $port
    set runaddress "\$8000"
    return 0;
}

init $argc $argv

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base {container 0}} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    wm focusmodel $base passive
    wm geometry $base 1x1+0+0
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vt.tcl"
    }
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {base {container 0}} {
    if {$base == ""} {
        set base .top17
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    toplevel $base -class Toplevel \
        -menu "$base.m19"
    wm focusmodel $base passive
    wm geometry $base 396x385+51+148
    wm iconname $base tkspgmr
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "TkSpgmr"
    }
    frame $base.cpd29 \
        -borderwidth {1} -height {30} -relief {raised} -width {30}
    menubutton $base.cpd29.01 \
        -anchor {w} -menu "$base.cpd29.01.02" -padx {4} -pady {3} \
        -text {File}
    menu $base.cpd29.01.02 \
        -cursor {} -tearoff {0}
    $base.cpd29.01.02 add command \
        -command {get_srec_filename} -label {S19 File..}
    $base.cpd29.01.02 add command \
        -label {Preferences..}
    $base.cpd29.01.02 add command \
        -command {xexit 0} -label {Exit}
    menubutton $base.cpd29.03 \
        -anchor {w} -menu "$base.cpd29.03.04" -padx {4} -pady {3} \
        -text {Target}
    menu $base.cpd29.03.04 \
        -cursor {} -tearoff {0}
    $base.cpd29.03.04 add cascade \
        -menu "$base.cpd29.03.04.men17" -label {CPU} -state {active}
    $base.cpd29.03.04 add cascade \
        -menu "$base.cpd29.03.04.men18" -label {Security Codes}
    menu $base.cpd29.03.04.men17 \
        -tearoff {0}
    $base.cpd29.03.04.men17 add command \
        \
        -command {Window show $widget(dlg_selcpu)
Window raise $widget(dlg_selcpu)} \
        -label {Select..}
    $base.cpd29.03.04.men17 add command \
        \
        -command {Window show $widget(dlg_cfg_gp32)
Window show $widget(dlg_cfg_gp32)} \
        -label {Configure..}
    menu $base.cpd29.03.04.men18 \
        -tearoff {0}
    $base.cpd29.03.04.men18 add command \
        -command {spgmr:write "scodes show all"} -label {Show}
    $base.cpd29.03.04.men18 add command \
        -label {Edit..}
    $base.cpd29.03.04.men18 add command \
        \
        -command {if { $srec_filename != "" } {
    spgmr:write "scodes set from $srec_filename"
}} \
        -label {Read}
    $base.cpd29.03.04.men18 add command \
        \
        -command {set tmp [get_filename s19 $srec_filename]
if { $tmp != "" } {
    spgmr:write "scodes set from $tmp"
}} \
        -label {Read From..}
    $base.cpd29.03.04.men18 add cascade \
        -menu "$base.cpd29.03.04.men18.men17" -label {Try}
    menu $base.cpd29.03.04.men18.men17
    $base.cpd29.03.04.men18.men17 add command \
        -command {do_reset 1 0} -label {Try 0}
    $base.cpd29.03.04.men18.men17 add command \
        -command {do_reset 1 1} -label {Try 1}
    $base.cpd29.03.04.men18.men17 add command \
        -command {do_reset 1 2} -label {Try 2}
    $base.cpd29.03.04.men18.men17 add command \
        -command {do_reset 1 3} -label {Try 3}
    $base.cpd29.03.04.men18.men17 add command \
        -command {do_reset 1 4} -label {Try 4}
    $base.cpd29.03.04.men18.men17 add command \
        -command {do_reset 1 5} -label {Try 5}
    $base.cpd29.03.04.men18.men17 add command \
        -command {do_reset 1 6} -label {Try 6}
    $base.cpd29.03.04.men18.men17 add command \
        -command {do_reset 1 7} -label {Try 7}
    $base.cpd29.03.04.men18.men17 add command \
        -command {do_reset 1 8} -label {Try 8}
    $base.cpd29.03.04.men18.men17 add command \
        -command {do_reset 1 9} -label {Try 9}
    menubutton $base.cpd29.05 \
        -anchor {w} -menu "$base.cpd29.05.06" -padx {4} -pady {3} \
        -text {Help} -width {4}
    menu $base.cpd29.05.06 \
        -cursor {} -tearoff {0}
    menubutton $base.cpd29.men30 \
        -anchor {w} -menu "$base.cpd29.men30.01" -padx {4} -pady {3} \
        -text {Program Ops}
    menu $base.cpd29.men30.01 \
        -cursor {} -tearoff {0}
    $base.cpd29.men30.01 add command \
        -command {do_reset 1} -label {Reset}
    $base.cpd29.men30.01 add cascade \
        -menu "$base.cpd29.men30.01.men17" -label {Flash}
    $base.cpd29.men30.01 add cascade \
        -menu "$base.cpd29.men30.01.men18" -label {EEPROM}
    $base.cpd29.men30.01 add command \
        \
        -command {set tmp [get_filename scr ""]
if { $tmp != "" } {
    spgmr:write "source $tmp"
}} \
        -label {Run Script..}
    menu $base.cpd29.men30.01.men17 \
        -tearoff {0}
    $base.cpd29.men30.01.men17 add command \
        -label {Mass Erase}
    $base.cpd29.men30.01.men17 add command \
        -label {Page Erase..}
    $base.cpd29.men30.01.men17 add command \
        -label {Program}
    $base.cpd29.men30.01.men17 add command \
        -label {Program From..}
    $base.cpd29.men30.01.men17 add command \
        -label {Program Bytes..}
    $base.cpd29.men30.01.men17 add command \
        -label {Verify}
    menu $base.cpd29.men30.01.men18 \
        -tearoff {0}
    $base.cpd29.men30.01.men18 add command \
        -label {Bulk Erase}
    $base.cpd29.men30.01.men18 add command \
        -label {Erase..}
    $base.cpd29.men30.01.men18 add command \
        -label {Program}
    $base.cpd29.men30.01.men18 add command \
        -label {Program From..}
    $base.cpd29.men30.01.men18 add command \
        -label {Program Bytes..}
    $base.cpd29.men30.01.men18 add command \
        -label {Verify}
    menubutton $base.cpd29.men32 \
        -anchor {w} -menu "$base.cpd29.men32.01" -padx {4} -pady {3} \
        -text {Windows}
    menu $base.cpd29.men32.01 \
        -cursor {} -tearoff {0}
    $base.cpd29.men32.01 add command \
        \
        -command {$widget(x_text) delete 0.0 end; $widget(x_text) insert end "";} \
        -label {Clear Display}
    $base.cpd29.men32.01 add command \
        \
        -command {Window show $widget(dlg_readdata)
Window raise $widget(dlg_readdata)} \
        -label {Read Target Data..}
    $base.cpd29.men32.01 add command \
        -command {spgmr:write "scope on"} -label {Serial Scope}
    $base.cpd29.men32.01 add command \
        -label {Arrange}
    $base.cpd29.men32.01 add command \
        -label {Save Layout}
    menubutton $base.cpd29.men17 \
        -anchor {w} -menu "$base.cpd29.men17.01" -padx {4} -pady {3} \
        -text {Server}
    menu $base.cpd29.men17.01 \
        -cursor {} -tearoff {0}
    $base.cpd29.men17.01 add command \
        -command {spgmr:abort} -label {Abort}
    $base.cpd29.men17.01 add command \
        -command {spgmr:stop} -label {Stop}
    $base.cpd29.men17.01 add command \
        -command {spgmr:start} -label {Start}
    $base.cpd29.men17.01 add command \
        \
        -command {Window show $widget(dlg_debugTkspgmr)
Window raise $widget(dlg_debugTkspgmr)} \
        -label {Debug..}
    $base.cpd29.men17.01 add command \
        \
        -command {Window show $widget(dlg_about_server)
x_clear x_about_server
Window raise $widget(dlg_about_server)
spgmr:write x_about_server "version"
while { $spgmr_busy } { update }
spgmr:write x_about_server "cpu"} \
        -label {About..}
    frame $base.fra34 \
        -borderwidth {2} -height {75} -relief {groove} -width {125}
    frame $base.fra34.01 \
        -borderwidth {1} -height {30} -relief {raised} -width {30}
    label $base.fra34.01.02 \
        -anchor {w} -relief {groove} -text {Spgmr Cmd:}
    entry $base.fra34.01.03 \
        -cursor {} -font [vTcl:font:get_font "vTcl:font10"] \
        -highlightthickness {0} -textvariable {x_command}
    bind $base.fra34.01.03 <Key-Return> {
        enter_cmd %W
    }
    frame $base.fra34.04 \
        -height {75} -width {125}
    frame $base.fra34.04.05 \
        -borderwidth {1} -height {30} -relief {raised}
    scrollbar $base.fra34.04.05.06 \
        -command "$base.fra34.04.05.08 xview" -orient {horizontal} \
        -width {10}
    scrollbar $base.fra34.04.05.07 \
        -command "$base.fra34.04.05.08 yview" -width {10}
    text $base.fra34.04.05.08 \
        -background {#f0f0f0} -font [vTcl:font:get_font "vTcl:font10"] \
        -height {1} -width {1} -wrap {none} \
        -xscrollcommand "$base.fra34.04.05.06 set" \
        -yscrollcommand "$base.fra34.04.05.07 set"
    frame $base.fra34.04.09 \
        -height {75} -width {80}
    frame $base.fra34.04.09.015 \
        -height {75} -relief {groove} -width {125}
    button $base.fra34.04.09.015.016 \
        -command {do_reset $reset_sure} -pady {2} -text {Reset}
    button $base.fra34.04.09.015.017 \
        \
        -command {do_erase $erase_sure
while { $spgmr_busy } { update }
do_reset 1 "blank"} \
        -pady {2} -text {Erase}
    button $base.fra34.04.09.015.018 \
        -command {do_program $program_sure} -pady {2} -text {Program}
    button $base.fra34.04.09.015.019 \
        -command {do_verify} -pady {2} -text {Verify}
    checkbutton $base.fra34.04.09.015.020 \
        -text {I'm sure} -variable {reset_sure}
    checkbutton $base.fra34.04.09.015.021 \
        -text {I'm sure} -variable {erase_sure}
    checkbutton $base.fra34.04.09.015.022 \
        -text {I'm sure} -variable {program_sure}
    button $base.fra34.04.09.015.but17 \
        -command {spgmr:write "run $runaddress"} -pady {2} -text {Run:}
    entry $base.fra34.04.09.015.ent18 \
        -background {#f0f0f0} -cursor {} \
        -font [vTcl:font:get_font "vTcl:font10"] -textvariable {runaddress} \
        -width {0}
    frame $base.fra34.04.09.fra28 \
        -borderwidth {2} -height {75} -relief {groove} -width {125}
    button $base.fra34.04.09.fra28.01 \
        -command {x_clear x_text} -pady {2} -text {Clear}
    checkbutton $base.fra34.04.09.fra28.02 \
        -text {Busy} -variable {spgmr_busy}
    frame $base.fra34.04.09.fra30 \
        -borderwidth {1} -height {30} -relief {raised} -width {30}
    entry $base.fra34.04.09.fra30.01 \
        -background {#f0f0f0} -cursor {} \
        -font [vTcl:font:get_font "vTcl:font10"] \
        -textvariable {srec_filename}
    button $base.fra34.04.09.fra30.02 \
        -command {get_srec_filename} -pady {2} -text {S19 File:}
    button $base.fra34.04.09.but19 \
        -command {spgmr:abort} -pady {2} -text {Abort}
    frame $base.fra34.04.09.cpd17 \
        -borderwidth {1} -height {30} -relief {raised} -width {30}
    label $base.fra34.04.09.cpd17.01 \
        -anchor {w} -relief {groove} -text {Proc:} -width {6}
    entry $base.fra34.04.09.cpd17.02 \
        -cursor {} -font [vTcl:font:get_font "vTcl:font10"] \
        -highlightthickness {0} -state {disabled} -textvariable {cpu} \
        -width {0}
    frame $base.fra34.04.09.cpd18 \
        -borderwidth {1} -height {30} -relief {raised} -width {30}
    label $base.fra34.04.09.cpd18.01 \
        -anchor {w} -relief {groove} -text {Port:} -width {6}
    entry $base.fra34.04.09.cpd18.02 \
        -cursor {} -font [vTcl:font:get_font "vTcl:font10"] \
        -highlightthickness {0} -state {disabled} -textvariable {port} \
        -width {0}
    menu $base.m19 \
        -borderwidth {0} -cursor {} -relief {groove} -tearoff {0}
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.cpd29 \
        -in $base -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.cpd29.01 \
        -in $base.cpd29 -anchor {center} -expand {0} -fill {none} \
        -side {left}
    pack $base.cpd29.03 \
        -in $base.cpd29 -anchor {center} -expand {0} -fill {none} \
        -side {left}
    pack $base.cpd29.05 \
        -in $base.cpd29 -anchor {center} -expand {0} -fill {none} \
        -side {right}
    pack $base.cpd29.men30 \
        -in $base.cpd29 -anchor {center} -expand {0} -fill {none} \
        -side {left}
    pack $base.cpd29.men32 \
        -in $base.cpd29 -anchor {center} -expand {0} -fill {none} \
        -side {left}
    pack $base.cpd29.men17 \
        -in $base.cpd29 -anchor {center} -expand {0} -fill {none} \
        -side {left}
    pack $base.fra34 \
        -in $base -anchor {center} -expand {1} -fill {both} -padx {8} \
        -pady {8} -side {top}
    pack $base.fra34.01 \
        -in $base.fra34 -anchor {center} -expand {0} -fill {x} -side {bottom}
    pack $base.fra34.01.02 \
        -in $base.fra34.01 -anchor {center} -expand {0} -fill {none} \
        -padx {2} -pady {2} -side {left}
    pack $base.fra34.01.03 \
        -in $base.fra34.01 -anchor {center} -expand {1} -fill {x} -padx {2} \
        -pady {2} -side {right}
    pack $base.fra34.04 \
        -in $base.fra34 -anchor {center} -expand {1} -fill {both} -side {top}
    pack $base.fra34.04.05 \
        -in $base.fra34.04 -anchor {nw} -expand {1} -fill {both} \
        -side {right}
    grid columnconf $base.fra34.04.05 0 -weight 1
    grid rowconf $base.fra34.04.05 0 -weight 1
    grid $base.fra34.04.05.06 \
        -in $base.fra34.04.05 -column {0} -row {1} -columnspan {1} \
        -rowspan {1} -sticky {ew}
    grid $base.fra34.04.05.07 \
        -in $base.fra34.04.05 -column {1} -row {0} -columnspan {1} \
        -rowspan {1} -sticky {ns}
    grid $base.fra34.04.05.08 \
        -in $base.fra34.04.05 -column {0} -row {0} -columnspan {1} \
        -rowspan {1} -sticky {nesw}
    pack $base.fra34.04.09 \
        -in $base.fra34.04 -anchor {n} -expand {0} -fill {both} -side {left}
    pack $base.fra34.04.09.015 \
        -in $base.fra34.04.09 -anchor {center} -expand {0} -fill {none} \
        -side {top}
    grid $base.fra34.04.09.015.016 \
        -in $base.fra34.04.09.015 -column {0} -row {0} -columnspan {1} \
        -rowspan {1} -sticky {nesw}
    grid $base.fra34.04.09.015.017 \
        -in $base.fra34.04.09.015 -column {0} -row {1} -columnspan {1} \
        -rowspan {1} -sticky {nesw}
    grid $base.fra34.04.09.015.018 \
        -in $base.fra34.04.09.015 -column {0} -row {2} -columnspan {1} \
        -rowspan {1} -sticky {nesw}
    grid $base.fra34.04.09.015.019 \
        -in $base.fra34.04.09.015 -column {0} -row {3} -columnspan {1} \
        -rowspan {1} -sticky {nesw}
    grid $base.fra34.04.09.015.020 \
        -in $base.fra34.04.09.015 -column {1} -row {0} -columnspan {1} \
        -rowspan {1} -sticky {w}
    grid $base.fra34.04.09.015.021 \
        -in $base.fra34.04.09.015 -column {1} -row {1} -columnspan {1} \
        -rowspan {1} -sticky {w}
    grid $base.fra34.04.09.015.022 \
        -in $base.fra34.04.09.015 -column {1} -row {2} -columnspan {1} \
        -rowspan {1} -sticky {w}
    grid $base.fra34.04.09.015.but17 \
        -in $base.fra34.04.09.015 -column {0} -row {4} -columnspan {1} \
        -rowspan {1} -sticky {nesw}
    grid $base.fra34.04.09.015.ent18 \
        -in $base.fra34.04.09.015 -column {1} -row {4} -columnspan {1} \
        -rowspan {1} -sticky {nesw}
    pack $base.fra34.04.09.fra28 \
        -in $base.fra34.04.09 -anchor {center} -expand {0} -fill {x} \
        -side {bottom}
    pack $base.fra34.04.09.fra28.01 \
        -in $base.fra34.04.09.fra28 -anchor {w} -expand {0} -fill {none} \
        -side {right}
    pack $base.fra34.04.09.fra28.02 \
        -in $base.fra34.04.09.fra28 -anchor {center} -expand {0} -fill {none} \
        -side {left}
    pack $base.fra34.04.09.fra30 \
        -in $base.fra34.04.09 -anchor {center} -expand {0} -fill {x} \
        -side {top}
    pack $base.fra34.04.09.fra30.01 \
        -in $base.fra34.04.09.fra30 -anchor {center} -expand {0} -fill {x} \
        -padx {2} -pady {2} -side {bottom}
    pack $base.fra34.04.09.fra30.02 \
        -in $base.fra34.04.09.fra30 -anchor {center} -expand {0} -fill {none} \
        -side {left}
    pack $base.fra34.04.09.but19 \
        -in $base.fra34.04.09 -anchor {center} -expand {0} -fill {none} \
        -side {bottom}
    pack $base.fra34.04.09.cpd17 \
        -in $base.fra34.04.09 -anchor {center} -expand {0} -fill {x} \
        -side {top}
    pack $base.fra34.04.09.cpd17.01 \
        -in $base.fra34.04.09.cpd17 -anchor {center} -expand {0} -fill {none} \
        -padx {2} -pady {2} -side {left}
    pack $base.fra34.04.09.cpd17.02 \
        -in $base.fra34.04.09.cpd17 -anchor {center} -expand {1} -fill {x} \
        -padx {2} -pady {2} -side {right}
    pack $base.fra34.04.09.cpd18 \
        -in $base.fra34.04.09 -anchor {center} -expand {0} -fill {x} \
        -side {top}
    pack $base.fra34.04.09.cpd18.01 \
        -in $base.fra34.04.09.cpd18 -anchor {center} -expand {0} -fill {none} \
        -padx {2} -pady {2} -side {left}
    pack $base.fra34.04.09.cpd18.02 \
        -in $base.fra34.04.09.cpd18 -anchor {center} -expand {1} -fill {x} \
        -padx {2} -pady {2} -side {right}
}

proc vTclWindow.top18 {base {container 0}} {
    if {$base == ""} {
        set base .top18
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 445x264+147+336
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Configure GP24/32"
    }
    frame $base.cpd40  -borderwidth {1} -height {30} -relief {raised} -width {30}
    menubutton $base.cpd40.01  -anchor {w} -menu "$base.cpd40.01.02" -padx {4} -pady {3}  -text {File} -width {4}
    menu $base.cpd40.01.02  -cursor {} -tearoff {0}
    $base.cpd40.01.02 add command  -label {Open Config..}
    $base.cpd40.01.02 add command  -label {Save Config}
    $base.cpd40.01.02 add command  -label {Save Config As..}
    menubutton $base.cpd40.03  -anchor {w} -menu "$base.cpd40.03.04" -padx {4} -pady {3}  -text {Preset}
    menu $base.cpd40.03.04  -cursor {} -tearoff {0}
    $base.cpd40.03.04 add command  -label {GP32}
    $base.cpd40.03.04 add command  -label {GP24}
    frame $base.fra41  -borderwidth {2} -height {75} -relief {groove} -width {125}
    frame $base.fra41.01  -borderwidth {2} -height {75} -relief {groove} -width {125}
    button $base.fra41.01.02  -command {Window hide $widget(dlg_selcpu)} -text {Ok}
    button $base.fra41.01.03  -command {Window hide $widget(dlg_selcpu)} -text {Cancel}
    frame $base.fra41.04  -borderwidth {1} -height {30} -relief {raised} -width {30}
    entry $base.fra41.04.05  -background {#f0f0f0} -cursor {} -font {Helvetica -12 bold}  -width {0}
    button $base.fra41.04.06  -anchor {e} -pady {2} -text {Erase module..} -width {15}
    frame $base.fra41.07  -borderwidth {1} -height {30} -relief {raised} -width {30}
    entry $base.fra41.07.08  -background {#f0f0f0} -cursor {} -font {Helvetica -12 bold}  -width {0}
    button $base.fra41.07.09  -anchor {e} -pady {2} -text {Program module..} -width {15}
    frame $base.fra41.fra43  -borderwidth {2} -height {75} -relief {groove} -width {125}
    frame $base.fra41.fra43.fra46  -borderwidth {2} -height {75} -relief {groove} -width {125}
    frame $base.fra41.fra43.fra46.fra48  -borderwidth {2} -height {75} -relief {groove} -width {125}
    label $base.fra41.fra43.fra46.fra48.01  -borderwidth {1} -relief {raised} -text {Omit Range}
    frame $base.fra41.fra43.fra46.fra48.02  -borderwidth {1} -height {30} -relief {raised} -width {30}
    label $base.fra41.fra43.fra46.fra48.02.03  -anchor {e} -relief {groove} -text {Start Address:} -width {14}
    entry $base.fra41.fra43.fra46.fra48.02.04  -background {#f0f0f0} -cursor {} -highlightthickness {0} -width {10}
    frame $base.fra41.fra43.fra46.fra48.05  -borderwidth {1} -height {30} -relief {raised} -width {30}
    label $base.fra41.fra43.fra46.fra48.05.06  -anchor {e} -relief {groove} -text {End Address:} -width {14}
    entry $base.fra41.fra43.fra46.fra48.05.07  -background {#f0f0f0} -cursor {} -highlightthickness {0} -width {10}
    frame $base.fra41.fra43.fra46.fra49  -borderwidth {2} -height {75} -relief {groove} -width {125}
    label $base.fra41.fra43.fra46.fra49.01  -borderwidth {1} -relief {raised} -text {Save Range}
    frame $base.fra41.fra43.fra46.fra49.02  -borderwidth {1} -height {30} -relief {raised} -width {30}
    label $base.fra41.fra43.fra46.fra49.02.03  -anchor {e} -relief {groove} -text {Start Address:} -width {14}
    entry $base.fra41.fra43.fra46.fra49.02.04  -background {#f0f0f0} -cursor {} -highlightthickness {0} -width {10}
    frame $base.fra41.fra43.fra46.fra49.05  -borderwidth {1} -height {30} -relief {raised} -width {30}
    label $base.fra41.fra43.fra46.fra49.05.06  -anchor {e} -relief {groove} -text {End Address:} -width {14}
    entry $base.fra41.fra43.fra46.fra49.05.07  -background {#f0f0f0} -cursor {} -highlightthickness {0} -width {10}
    ###################
    # SETTING GEOMETRY
    ###################
    grid columnconf $base 0 -minsize 175
    pack $base.cpd40  -in $base -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.cpd40.01  -in $base.cpd40 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.cpd40.03  -in $base.cpd40 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra41  -in $base -anchor {center} -expand {1} -fill {both} -padx {8}  -pady {8} -side {top}
    pack $base.fra41.01  -in $base.fra41 -anchor {center} -expand {0} -fill {x} -side {bottom}
    pack $base.fra41.01.02  -in $base.fra41.01 -anchor {center} -expand {1} -fill {x}  -side {left}
    pack $base.fra41.01.03  -in $base.fra41.01 -anchor {center} -expand {1} -fill {x}  -side {right}
    pack $base.fra41.04  -in $base.fra41 -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.fra41.04.05  -in $base.fra41.04 -anchor {center} -expand {1} -fill {x} -padx {2}  -pady {2} -side {right}
    pack $base.fra41.04.06  -in $base.fra41.04 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra41.07  -in $base.fra41 -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.fra41.07.08  -in $base.fra41.07 -anchor {center} -expand {1} -fill {x} -padx {2}  -pady {2} -side {right}
    pack $base.fra41.07.09  -in $base.fra41.07 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra41.fra43  -in $base.fra41 -anchor {center} -expand {1} -fill {both} -side {top}
    pack $base.fra41.fra43.fra46  -in $base.fra41.fra43 -anchor {center} -expand {0} -fill {x}  -side {top}
    pack $base.fra41.fra43.fra46.fra48  -in $base.fra41.fra43.fra46 -anchor {center} -expand {1} -fill {none}  -side {left}
    pack $base.fra41.fra43.fra46.fra48.01  -in $base.fra41.fra43.fra46.fra48 -anchor {center} -expand {0}  -fill {x} -side {top}
    pack $base.fra41.fra43.fra46.fra48.02  -in $base.fra41.fra43.fra46.fra48 -anchor {center} -expand {0}  -fill {none} -side {top}
    pack $base.fra41.fra43.fra46.fra48.02.03  -in $base.fra41.fra43.fra46.fra48.02 -anchor {center} -expand {0}  -fill {none} -padx {2} -pady {2} -side {left}
    pack $base.fra41.fra43.fra46.fra48.02.04  -in $base.fra41.fra43.fra46.fra48.02 -anchor {center} -expand {1}  -fill {x} -padx {2} -pady {2} -side {right}
    pack $base.fra41.fra43.fra46.fra48.05  -in $base.fra41.fra43.fra46.fra48 -anchor {center} -expand {0}  -fill {none} -side {top}
    pack $base.fra41.fra43.fra46.fra48.05.06  -in $base.fra41.fra43.fra46.fra48.05 -anchor {center} -expand {0}  -fill {none} -padx {2} -pady {2} -side {left}
    pack $base.fra41.fra43.fra46.fra48.05.07  -in $base.fra41.fra43.fra46.fra48.05 -anchor {center} -expand {1}  -fill {x} -padx {2} -pady {2} -side {right}
    pack $base.fra41.fra43.fra46.fra49  -in $base.fra41.fra43.fra46 -anchor {center} -expand {1} -fill {none}  -side {right}
    pack $base.fra41.fra43.fra46.fra49.01  -in $base.fra41.fra43.fra46.fra49 -anchor {center} -expand {0}  -fill {x} -side {top}
    pack $base.fra41.fra43.fra46.fra49.02  -in $base.fra41.fra43.fra46.fra49 -anchor {center} -expand {0}  -fill {none} -side {top}
    pack $base.fra41.fra43.fra46.fra49.02.03  -in $base.fra41.fra43.fra46.fra49.02 -anchor {center} -expand {0}  -fill {none} -padx {2} -pady {2} -side {left}
    pack $base.fra41.fra43.fra46.fra49.02.04  -in $base.fra41.fra43.fra46.fra49.02 -anchor {center} -expand {1}  -fill {x} -padx {2} -pady {2} -side {right}
    pack $base.fra41.fra43.fra46.fra49.05  -in $base.fra41.fra43.fra46.fra49 -anchor {center} -expand {0}  -fill {none} -side {top}
    pack $base.fra41.fra43.fra46.fra49.05.06  -in $base.fra41.fra43.fra46.fra49.05 -anchor {center} -expand {0}  -fill {none} -padx {2} -pady {2} -side {left}
    pack $base.fra41.fra43.fra46.fra49.05.07  -in $base.fra41.fra43.fra46.fra49.05 -anchor {center} -expand {1}  -fill {x} -padx {2} -pady {2} -side {right}
}

proc vTclWindow.top19 {base {container 0}} {
    if {$base == ""} {
        set base .top19
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 351x267+51+145
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Select CPU"
    }
    frame $base.fra20  -borderwidth {2} -height {75} -relief {groove} -width {125}
    frame $base.fra20.fra27  -borderwidth {2} -height {75} -relief {groove} -width {125}
    button $base.fra20.fra27.but28   -command {set cpu $selectedCPU
set port $selectedPort
spgmr:write "cpu $selectedCPU;serial port $selectedPort"
Window hide $widget(dlg_selcpu)}  -text {Ok}
    button $base.fra20.fra27.but29  -command {set $selectedCPU $cpu
Window hide $widget(dlg_selcpu)}  -text {Cancel}
    frame $base.fra20.fra18  -borderwidth {2} -height {219} -relief {groove} -width {125}
    label $base.fra20.fra18.lab19  -relief {groove} -text {Select CPU}
    frame $base.fra20.fra18.fra20  -borderwidth {2} -height {75} -width {125}
    radiobutton $base.fra20.fra18.fra20.01  -state {disabled} -text {GP24} -value {gp24} -variable {selectedCPU}
    radiobutton $base.fra20.fra18.fra20.02  -text {GP32} -value {gp32} -variable {selectedCPU}
    radiobutton $base.fra20.fra18.fra20.03  -text {AB32} -value {ab32} -variable {selectedCPU}
    frame $base.fra20.fra21  -borderwidth {2} -height {75} -relief {groove} -width {125}
    label $base.fra20.fra21.lab22  -relief {groove} -text {Select Port}
    frame $base.fra20.fra21.fra23  -borderwidth {2} -height {75} -width {125}
    radiobutton $base.fra20.fra21.fra23.rad24  -text {ttyS0} -value {/dev/ttyS0} -variable {selectedPort}
    radiobutton $base.fra20.fra21.fra23.rad32  -text {ttyS1} -value {/dev/ttyS1} -variable {selectedPort}
    radiobutton $base.fra20.fra21.fra23.rad33  -text {ttyS2} -value {/dev/ttyS2} -variable {selectedPort}
    radiobutton $base.fra20.fra21.fra23.rad34  -text {ttyS3} -value {/dev/ttyS3} -variable {selectedPort}
    radiobutton $base.fra20.fra21.fra23.rad35  -text {ttyS4} -value {/dev/ttyS4} -variable {selectedPort}
    radiobutton $base.fra20.fra21.fra23.rad36  -text {ttyS5} -value {/dev/ttyS5} -variable {selectedPort}
    radiobutton $base.fra20.fra21.fra23.rad37  -text {ttyS6} -value {/dev/ttyS6} -variable {selectedPort}
    radiobutton $base.fra20.fra21.fra23.rad38  -text {ttyS7} -value {/dev/ttyS7} -variable {selectedPort}
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra20  -in $base -anchor {center} -expand {1} -fill {both} -padx {8}  -pady {8} -side {top}
    pack $base.fra20.fra27  -in $base.fra20 -anchor {center} -expand {0} -fill {x} -side {bottom}
    pack $base.fra20.fra27.but28  -in $base.fra20.fra27 -anchor {center} -expand {1} -fill {x}  -side {left}
    pack $base.fra20.fra27.but29  -in $base.fra20.fra27 -anchor {center} -expand {1} -fill {x}  -side {right}
    pack $base.fra20.fra18  -in $base.fra20 -anchor {n} -expand {1} -fill {both} -side {left}
    pack $base.fra20.fra18.lab19  -in $base.fra20.fra18 -anchor {center} -expand {0} -fill {x}  -side {top}
    pack $base.fra20.fra18.fra20  -in $base.fra20.fra18 -anchor {center} -expand {0} -fill {none}  -side {top}
    grid $base.fra20.fra18.fra20.01  -in $base.fra20.fra18.fra20 -column {0} -row {0} -columnspan {1}  -rowspan {1}
    grid $base.fra20.fra18.fra20.02  -in $base.fra20.fra18.fra20 -column {0} -row {1} -columnspan {1}  -rowspan {1}
    grid $base.fra20.fra18.fra20.03  -in $base.fra20.fra18.fra20 -column {0} -row {2} -columnspan {1}  -rowspan {1}
    pack $base.fra20.fra21  -in $base.fra20 -anchor {n} -expand {1} -fill {both} -side {right}
    pack $base.fra20.fra21.lab22  -in $base.fra20.fra21 -anchor {center} -expand {0} -fill {x}  -side {top}
    pack $base.fra20.fra21.fra23  -in $base.fra20.fra21 -anchor {center} -expand {0} -fill {none}  -side {top}
    pack $base.fra20.fra21.fra23.rad24  -in $base.fra20.fra21.fra23 -anchor {center} -expand {0} -fill {none}  -side {top}
    pack $base.fra20.fra21.fra23.rad32  -in $base.fra20.fra21.fra23 -anchor {center} -expand {0} -fill {none}  -side {top}
    pack $base.fra20.fra21.fra23.rad33  -in $base.fra20.fra21.fra23 -anchor {center} -expand {0} -fill {none}  -side {top}
    pack $base.fra20.fra21.fra23.rad34  -in $base.fra20.fra21.fra23 -anchor {center} -expand {0} -fill {none}  -side {top}
    pack $base.fra20.fra21.fra23.rad35  -in $base.fra20.fra21.fra23 -anchor {center} -expand {0} -fill {none}  -side {top}
    pack $base.fra20.fra21.fra23.rad36  -in $base.fra20.fra21.fra23 -anchor {center} -expand {0} -fill {none}  -side {top}
    pack $base.fra20.fra21.fra23.rad37  -in $base.fra20.fra21.fra23 -anchor {center} -expand {0} -fill {none}  -side {top}
    pack $base.fra20.fra21.fra23.rad38  -in $base.fra20.fra21.fra23 -anchor {center} -expand {0} -fill {none}  -side {top}
}

proc vTclWindow.top20 {base {container 0}} {
    if {$base == ""} {
        set base .top20
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 291x221+120+410
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "About Server"
    }
    frame $base.fra21  -borderwidth {2} -height {75} -relief {groove} -width {125}
    frame $base.fra21.fra22  -borderwidth {2} -height {75} -relief {groove} -width {125}
    text $base.fra21.fra22.tex26  -height {1} -width {1}
    frame $base.fra21.fra23  -borderwidth {2} -height {75} -relief {groove} -width {125}
    button $base.fra21.fra23.but24  -command {Window hide $widget(dlg_about_server)} -text {Ok}
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra21  -in $base -anchor {center} -expand {1} -fill {both} -padx {8}  -pady {8} -side {top}
    pack $base.fra21.fra22  -in $base.fra21 -anchor {center} -expand {1} -fill {both} -side {top}
    pack $base.fra21.fra22.tex26  -in $base.fra21.fra22 -anchor {center} -expand {1} -fill {both}  -side {top}
    pack $base.fra21.fra23  -in $base.fra21 -anchor {center} -expand {0} -fill {x} -side {bottom}
    pack $base.fra21.fra23.but24  -in $base.fra21.fra23 -anchor {center} -expand {0} -fill {x}  -side {top}
}

proc vTclWindow.top24 {base {container 0}} {
    if {$base == ""} {
        set base .top24
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 640x255+10+678
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Read Data"
    }
    frame $base.fra25  -borderwidth {2} -height {75} -relief {groove} -width {125}
    frame $base.fra25.01  -borderwidth {1} -height {30} -relief {raised}
    scrollbar $base.fra25.01.02  -command "$base.fra25.01.04 xview" -orient {horizontal} -width {10}
    scrollbar $base.fra25.01.03  -command "$base.fra25.01.04 yview" -width {10}
    text $base.fra25.01.04  -background {#f0f0f0} -font [vTcl:font:get_font "vTcl:font10"]  -height {1} -width {1} -xscrollcommand "$base.fra25.01.02 set"  -yscrollcommand "$base.fra25.01.03 set"
    frame $base.fra25.05  -height {75} -width {80}
    frame $base.fra25.05.fra31  -borderwidth {2} -height {75} -relief {groove} -width {125}
    frame $base.fra25.05.fra31.fra19  -height {75} -relief {groove} -width {125}
    button $base.fra25.05.fra31.fra19.01  -command {Window hide $widget(dlg_readdata)} -pady {2} -text {Close}  -width {8}
    button $base.fra25.05.fra31.fra19.02  -command {x_clear x_data} -pady {2} -text {Clear}
    frame $base.fra25.05.fra31.fra27  -height {75} -width {125}
    label $base.fra25.05.fra31.fra27.lab28  -borderwidth {1} -relief {raised} -text {Read Target Data}  -width {20}
    frame $base.fra25.05.fra31.fra27.fra29  -borderwidth {1} -height {30} -relief {raised} -width {30}
    label $base.fra25.05.fra31.fra27.fra29.01  -anchor {e} -relief {groove} -text {Start:} -width {9}
    entry $base.fra25.05.fra31.fra27.fra29.02  -background {#f0f0f0} -cursor {}  -font [vTcl:font:get_font "vTcl:font10"] -highlightthickness {0}  -width {0}
    frame $base.fra25.05.fra31.fra27.fra30  -borderwidth {1} -height {30} -relief {raised} -width {30}
    radiobutton $base.fra25.05.fra31.fra27.fra30.01  -anchor {e} -justify {left} -relief {groove} -text {   End:}  -value {0} -variable {rb1} -width {6}
    entry $base.fra25.05.fra31.fra27.fra30.02  -background {#f0f0f0} -cursor {}  -font [vTcl:font:get_font "vTcl:font10"] -highlightthickness {0}  -width {0}
    frame $base.fra25.05.fra31.fra27.fra31  -borderwidth {1} -height {30} -relief {raised} -width {30}
    radiobutton $base.fra25.05.fra31.fra27.fra31.01  -anchor {e} -justify {left} -relief {groove} -text {Count:}  -value {1} -variable {rb1} -width {6}
    entry $base.fra25.05.fra31.fra27.fra31.02  -background {#f0f0f0} -cursor {}  -font [vTcl:font:get_font "vTcl:font10"] -highlightthickness {0}  -width {0}
    checkbutton $base.fra25.05.fra31.fra27.che32  -text {To File} -variable {che23}
    frame $base.fra25.05.fra31.fra27.fra33  -borderwidth {1} -height {30} -relief {raised} -width {30}
    entry $base.fra25.05.fra31.fra27.fra33.01  -background {#f0f0f0} -cursor {}  -font [vTcl:font:get_font "vTcl:font10"] -highlightthickness {0}  -textvariable {read_filename}
    button $base.fra25.05.fra31.fra27.fra33.02  -command {get_read_filename} -pady {2} -text {File:}
    button $base.fra25.05.fra31.fra27.but34   -command {set start [.top24.fra25.05.fra31.fra27.fra29.02 get]
set end [.top24.fra25.05.fra31.fra27.fra30.02 get]
set count [.top24.fra25.05.fra31.fra27.fra31.02 get]
set cnt 1
if { $rb1 == 0 } {
    set cmd "read $start:$end"
    set cnt 1024
} else {
    if { $count == "" } { set count [set cnt 1] }
    set cmd "read $start+$count"
}
# read rate is about 11.6 secs / k, use 14 in expr below
set s_timeout [expr { int ($cnt/1024.0) * 140 + 1 }]
set r_timeout 10

if { $che23 == 1 && $read_filename != "" } {
    append cmd " to $read_filename"
}
spgmr:write x_data $cmd}  -pady {2} -text {Read} -width {8}
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra25  -in $base -anchor {center} -expand {1} -fill {both} -padx {8}  -pady {8} -side {top}
    pack $base.fra25.01  -in $base.fra25 -anchor {center} -expand {1} -fill {both}  -side {left}
    grid columnconf $base.fra25.01 0 -weight 1
    grid rowconf $base.fra25.01 0 -weight 1
    grid $base.fra25.01.02  -in $base.fra25.01 -column {0} -row {1} -columnspan {1} -rowspan {1}  -sticky {ew}
    grid $base.fra25.01.03  -in $base.fra25.01 -column {1} -row {0} -columnspan {1} -rowspan {1}  -sticky {ns}
    grid $base.fra25.01.04  -in $base.fra25.01 -column {0} -row {0} -columnspan {1} -rowspan {1}  -sticky {nesw}
    pack $base.fra25.05  -in $base.fra25 -anchor {center} -expand {0} -fill {both}  -side {right}
    pack $base.fra25.05.fra31  -in $base.fra25.05 -anchor {center} -expand {1} -fill {y} -side {top}
    pack $base.fra25.05.fra31.fra19  -in $base.fra25.05.fra31 -anchor {center} -expand {0} -fill {x}  -side {bottom}
    pack $base.fra25.05.fra31.fra19.01  -in $base.fra25.05.fra31.fra19 -anchor {center} -expand {1} -fill {x}  -side {right}
    pack $base.fra25.05.fra31.fra19.02  -in $base.fra25.05.fra31.fra19 -anchor {center} -expand {1} -fill {x}  -side {left}
    pack $base.fra25.05.fra31.fra27  -in $base.fra25.05.fra31 -anchor {center} -expand {0} -fill {both}  -side {top}
    grid columnconf $base.fra25.05.fra31.fra27 0 -weight 1
    grid columnconf $base.fra25.05.fra31.fra27 0 -minsize 175
    grid $base.fra25.05.fra31.fra27.lab28  -in $base.fra25.05.fra31.fra27 -column {0} -row {0} -columnspan {1}  -rowspan {1} -sticky {nesw}
    grid $base.fra25.05.fra31.fra27.fra29  -in $base.fra25.05.fra31.fra27 -column {0} -row {1} -columnspan {1}  -rowspan {1} -sticky {nesw}
    pack $base.fra25.05.fra31.fra27.fra29.01  -in $base.fra25.05.fra31.fra27.fra29 -anchor {center} -expand {0}  -fill {none} -padx {2} -pady {2} -side {left}
    pack $base.fra25.05.fra31.fra27.fra29.02  -in $base.fra25.05.fra31.fra27.fra29 -anchor {center} -expand {1}  -fill {x} -padx {2} -pady {2} -side {right}
    grid $base.fra25.05.fra31.fra27.fra30  -in $base.fra25.05.fra31.fra27 -column {0} -row {2} -columnspan {1}  -rowspan {1} -sticky {nesw}
    pack $base.fra25.05.fra31.fra27.fra30.01  -in $base.fra25.05.fra31.fra27.fra30 -anchor {center} -expand {0}  -fill {none} -side {left}
    pack $base.fra25.05.fra31.fra27.fra30.02  -in $base.fra25.05.fra31.fra27.fra30 -anchor {center} -expand {1}  -fill {x} -padx {2} -pady {2} -side {right}
    grid $base.fra25.05.fra31.fra27.fra31  -in $base.fra25.05.fra31.fra27 -column {0} -row {3} -columnspan {1}  -rowspan {1} -sticky {nesw}
    pack $base.fra25.05.fra31.fra27.fra31.01  -in $base.fra25.05.fra31.fra27.fra31 -anchor {center} -expand {0}  -fill {none} -side {left}
    pack $base.fra25.05.fra31.fra27.fra31.02  -in $base.fra25.05.fra31.fra27.fra31 -anchor {center} -expand {1}  -fill {x} -padx {2} -pady {2} -side {right}
    grid $base.fra25.05.fra31.fra27.che32  -in $base.fra25.05.fra31.fra27 -column {0} -row {4} -columnspan {1}  -rowspan {1} -sticky {w}
    grid $base.fra25.05.fra31.fra27.fra33  -in $base.fra25.05.fra31.fra27 -column {0} -row {5} -columnspan {1}  -rowspan {1} -sticky {nesw}
    pack $base.fra25.05.fra31.fra27.fra33.01  -in $base.fra25.05.fra31.fra27.fra33 -anchor {center} -expand {1}  -fill {x} -padx {2} -pady {2} -side {bottom}
    pack $base.fra25.05.fra31.fra27.fra33.02  -in $base.fra25.05.fra31.fra27.fra33 -anchor {center} -expand {0}  -fill {none} -side {left}
    grid $base.fra25.05.fra31.fra27.but34  -in $base.fra25.05.fra31.fra27 -column {0} -row {6} -columnspan {1}  -rowspan {1} -sticky {nesw}
}

proc vTclWindow.top26 {base {container 0}} {
    if {$base == ""} {
        set base .top26
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 646x296+67+816
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "New Toplevel 6"
    }
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top29 {base {container 0}} {
    if {$base == ""} {
        set base .top29
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 239x380+399+171
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Debug"
    }
    frame $base.fra30  -borderwidth {2} -height {75} -relief {groove} -width {80}
    frame $base.fra30.01  -borderwidth {2} -height {75} -relief {groove} -width {125}
    frame $base.fra30.01.02  -borderwidth {1} -height {30} -relief {raised} -width {30}
    label $base.fra30.01.02.03  -anchor {w} -relief {groove} -text {Cmd:}
    entry $base.fra30.01.02.04  -cursor {} -font [vTcl:font:get_font "vTcl:font10"]  -highlightthickness {0} -textvariable {tcl_command}
    bind $base.fra30.01.02.04 <Key-Return> {
        xputs [eval $tcl_command];
    }
    frame $base.fra30.05  -borderwidth {2} -height {75} -relief {groove} -width {125}
    label $base.fra30.05.06  -borderwidth {1} -relief {raised} -text {Spgmr Control}
    button $base.fra30.05.07  -command {spgmr:start} -text {Start}
    button $base.fra30.05.08  -command {spgmr:stop} -text {Stop}
    frame $base.fra30.09  -borderwidth {2} -height {75} -relief {groove} -width {125}
    frame $base.fra30.09.010  -borderwidth {2} -height {75} -width {125}
    label $base.fra30.09.010.011  -borderwidth {1} -relief {raised} -text {Debug Control}
    checkbutton $base.fra30.09.010.che27   -command {if { $che_dbg } {
    spgmr:write "debug on"
} else {
    spgmr:write "debug off"
}}  -indicatoron {0} -padx {3m} -pady {1m} -selectcolor {#008cff}  -text {Debug} -variable {che_dbg}
    checkbutton $base.fra30.09.010.che28   -command {if { $che_sdbg } {
    spgmr:write "debug serial on"
} else {
    spgmr:write "debug serial off"
}}  -indicatoron {0} -padx {3m} -pady {1m} -selectcolor {#008cff}  -text {Serial} -variable {che_sdbg}
    checkbutton $base.fra30.09.010.che29   -command {if { $che_mdbg } {
    spgmr:write "debug monitor on"
} else {
    spgmr:write "debug monitor off"
}}  -indicatoron {0} -padx {3m} -pady {1m} -selectcolor {#008cff}  -text {Monitor} -variable {che_mdbg}
    frame $base.fra30.09.016  -borderwidth {2} -height {75} -width {125}
    label $base.fra30.09.016.017  -borderwidth {1} -relief {raised} -text {Commands}
    frame $base.fra30.09.016.018  -borderwidth {2} -height {75} -relief {groove} -width {125}
    button $base.fra30.09.016.018.019  -command {spgmr:write "scope on"} -text {Scope}
    button $base.fra30.09.016.018.but21  -command {spgmr:write "debug fileinfo"
fileinfo} -text {fileinfo}
    button $base.fra30.09.016.018.but22  -command {spgmr:write "wcodes"} -text {Wcodes}
    button $base.fra30.09.023  -command {Window hide $widget(dlg_debugTkspgmr)} -text {Close}
    frame $base.fra30.09.fra21  -borderwidth {2} -height {75} -relief {groove} -width {125}
    button $base.fra30.09.fra21.01  -command {if {$xpid != -1 } {
    kill SIGUSR1 $xpid
}}  -text {SIGUSR1}
    button $base.fra30.09.fra21.02  -command {if {$xpid != -1 } {
    kill SIGUSR2 $xpid
}}  -text {SIGUSR2}
    frame $base.fra30.09.fra22  -borderwidth {1} -height {30} -relief {raised} -width {30}
    label $base.fra30.09.fra22.01  -anchor {w} -relief {groove} -text {Timeout}
    entry $base.fra30.09.fra22.02  -cursor {} -highlightthickness {0} -textvariable {s_timeout}
    frame $base.fra30.09.fra23  -borderwidth {2} -height {75} -relief {groove} -width {125}
    checkbutton $base.fra30.09.fra23.01  -text {spgmr busy} -variable {spgmr_busy}
    checkbutton $base.fra30.09.fra23.02  -text {spgmr active} -variable {spgmr_active}
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra30  -in $base -anchor {center} -expand {1} -fill {both} -side {right}
    pack $base.fra30.01  -in $base.fra30 -anchor {center} -expand {0} -fill {x} -side {bottom}
    pack $base.fra30.01.02  -in $base.fra30.01 -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.fra30.01.02.03  -in $base.fra30.01.02 -anchor {center} -expand {0} -fill {none}  -padx {2} -pady {2} -side {left}
    pack $base.fra30.01.02.04  -in $base.fra30.01.02 -anchor {center} -expand {1} -fill {x}  -padx {2} -pady {2} -side {right}
    pack $base.fra30.05  -in $base.fra30 -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.fra30.05.06  -in $base.fra30.05 -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.fra30.05.07  -in $base.fra30.05 -anchor {center} -expand {1} -fill {x}  -side {left}
    pack $base.fra30.05.08  -in $base.fra30.05 -anchor {center} -expand {1} -fill {x}  -side {right}
    pack $base.fra30.09  -in $base.fra30 -anchor {center} -expand {1} -fill {both} -padx {4}  -side {top}
    pack $base.fra30.09.010  -in $base.fra30.09 -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.fra30.09.010.011  -in $base.fra30.09.010 -anchor {center} -expand {0} -fill {x}  -side {top}
    pack $base.fra30.09.010.che27  -in $base.fra30.09.010 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra30.09.010.che28  -in $base.fra30.09.010 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra30.09.010.che29  -in $base.fra30.09.010 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra30.09.016  -in $base.fra30.09 -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.fra30.09.016.017  -in $base.fra30.09.016 -anchor {center} -expand {0} -fill {none}  -side {top}
    pack $base.fra30.09.016.018  -in $base.fra30.09.016 -anchor {center} -expand {0} -fill {x}  -side {top}
    pack $base.fra30.09.016.018.019  -in $base.fra30.09.016.018 -anchor {n} -expand {0} -fill {none}  -side {left}
    pack $base.fra30.09.016.018.but21  -in $base.fra30.09.016.018 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra30.09.016.018.but22  -in $base.fra30.09.016.018 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra30.09.023  -in $base.fra30.09 -anchor {center} -expand {0} -fill {x}  -side {bottom}
    pack $base.fra30.09.fra21  -in $base.fra30.09 -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.fra30.09.fra21.01  -in $base.fra30.09.fra21 -anchor {center} -expand {1} -fill {x}  -side {left}
    pack $base.fra30.09.fra21.02  -in $base.fra30.09.fra21 -anchor {center} -expand {1} -fill {x}  -side {right}
    pack $base.fra30.09.fra22  -in $base.fra30.09 -anchor {center} -expand {0} -fill {none}  -side {top}
    pack $base.fra30.09.fra22.01  -in $base.fra30.09.fra22 -anchor {center} -expand {0} -fill {none}  -padx {2} -pady {2} -side {left}
    pack $base.fra30.09.fra22.02  -in $base.fra30.09.fra22 -anchor {center} -expand {1} -fill {x}  -padx {2} -pady {2} -side {right}
    pack $base.fra30.09.fra23  -in $base.fra30.09 -anchor {center} -expand {0} -fill {none}  -side {top}
    pack $base.fra30.09.fra23.01  -in $base.fra30.09.fra23 -anchor {center} -expand {0} -fill {none}  -side {top}
    pack $base.fra30.09.fra23.02  -in $base.fra30.09.fra23 -anchor {center} -expand {0} -fill {none}  -side {top}
}

proc vTclWindow.top52 {base {container 0}} {
    if {$base == ""} {
        set base .top52
    }
    if {[winfo exists $base] && (!$container)} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    if {!$container} {
    toplevel $base -class Toplevel  -cursor {xterm} -menu "$base.m17"
    wm focusmodel $base passive
    wm geometry $base 339x362+261+494
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "New Toplevel 5"
    }
    frame $base.fra17  -borderwidth {1} -height {30} -relief {raised} -width {30}
    menubutton $base.fra17.01  -anchor {w} -menu "$base.fra17.01.02" -padx {4} -pady {3}  -text {File}
    menu $base.fra17.01.02  -cursor {} -tearoff {0}
    $base.fra17.01.02 add command  -command {get_srec_filename} -label {S19 File..}
    $base.fra17.01.02 add command  -label {Preferences..}
    $base.fra17.01.02 add command  -command {xexit 0} -label {Exit}
    menubutton $base.fra17.03  -anchor {w} -menu "$base.fra17.03.04" -padx {4} -pady {3}  -text {Target}
    menu $base.fra17.03.04  -cursor {} -tearoff {0}
    $base.fra17.03.04 add cascade  -menu "$base.cpd29.03.04.men17" -label {CPU} -state {active}
    $base.fra17.03.04 add cascade  -menu "$base.cpd29.03.04.men18" -label {Security Codes}
    menu $base.fra17.03.04.05  -tearoff {0}
    $base.fra17.03.04.05 add command   -command {Window show $widget(dlg_selcpu)
Window raise $widget(dlg_selcpu)}  -label {Select..}
    $base.fra17.03.04.05 add command   -command {Window show $widget(dlg_cfg_gp32)
Window show $widget(dlg_cfg_gp32)}  -label {Configure..}
    menu $base.fra17.03.04.06  -tearoff {0}
    $base.fra17.03.04.06 add command  -command {spgmr:write "scodes show all"} -label {Show}
    $base.fra17.03.04.06 add command  -label {Edit..}
    $base.fra17.03.04.06 add command   -command {if { $srec_filename != "" } {
    spgmr:write "scodes set from $srec_filename"
}}  -label {Read}
    $base.fra17.03.04.06 add command   -command {set tmp [get_filename s19 $srec_filename]
if { $tmp != "" } {
    spgmr:write "scodes set from $tmp"
}}  -label {Read From..}
    $base.fra17.03.04.06 add cascade  -menu "$base.cpd29.03.04.men18.men17" -label {Try}
    menu $base.fra17.03.04.06.07
    $base.fra17.03.04.06.07 add command  -command {do_reset 1 0} -label {Try 0}
    $base.fra17.03.04.06.07 add command  -command {do_reset 1 1} -label {Try 1}
    $base.fra17.03.04.06.07 add command  -command {do_reset 1 2} -label {Try 2}
    $base.fra17.03.04.06.07 add command  -command {do_reset 1 3} -label {Try 3}
    $base.fra17.03.04.06.07 add command  -command {do_reset 1 4} -label {Try 4}
    $base.fra17.03.04.06.07 add command  -command {do_reset 1 5} -label {Try 5}
    $base.fra17.03.04.06.07 add command  -command {do_reset 1 6} -label {Try 6}
    $base.fra17.03.04.06.07 add command  -command {do_reset 1 7} -label {Try 7}
    $base.fra17.03.04.06.07 add command  -command {do_reset 1 8} -label {Try 8}
    $base.fra17.03.04.06.07 add command  -command {do_reset 1 9} -label {Try 9}
    menubutton $base.fra17.08  -anchor {w} -menu "$base.fra17.08.09" -padx {4} -pady {3}  -text {Help} -width {4}
    menu $base.fra17.08.09  -cursor {} -tearoff {0}
    menubutton $base.fra17.010  -anchor {w} -menu "$base.fra17.010.011" -padx {4} -pady {3}  -text {Program Ops}
    menu $base.fra17.010.011  -cursor {} -tearoff {0}
    $base.fra17.010.011 add command  -command {do_reset 1} -label {Reset} -state {active}
    $base.fra17.010.011 add cascade  -menu "$base.cpd29.men30.01.men17" -label {Flash}
    $base.fra17.010.011 add cascade  -menu "$base.cpd29.men30.01.men18" -label {EEPROM}
    $base.fra17.010.011 add command   -command {set tmp [get_filename scr ""]
if { $tmp != "" } {
    spgmr:write "source $tmp"
}}  -label {Run Script..}
    menu $base.fra17.010.011.012  -tearoff {0}
    $base.fra17.010.011.012 add command  -label {Mass Erase}
    $base.fra17.010.011.012 add command  -label {Page Erase..}
    $base.fra17.010.011.012 add command  -label {Program}
    $base.fra17.010.011.012 add command  -label {Program From..}
    $base.fra17.010.011.012 add command  -label {Program Bytes..}
    $base.fra17.010.011.012 add command  -label {Verify}
    menu $base.fra17.010.011.013  -tearoff {0}
    $base.fra17.010.011.013 add command  -label {Bulk Erase}
    $base.fra17.010.011.013 add command  -label {Erase..}
    $base.fra17.010.011.013 add command  -label {Program}
    $base.fra17.010.011.013 add command  -label {Program From..}
    $base.fra17.010.011.013 add command  -label {Program Bytes..}
    $base.fra17.010.011.013 add command  -label {Verify}
    menubutton $base.fra17.014  -anchor {w} -menu "$base.fra17.014.015" -padx {4} -pady {3}  -text {Windows}
    menu $base.fra17.014.015  -cursor {} -tearoff {0}
    $base.fra17.014.015 add command   -command {$widget(x_text) delete 0.0 end; $widget(x_text) insert end "";}  -label {Clear Display}
    $base.fra17.014.015 add command   -command {Window show $widget(dlg_readdata)
Window raise $widget(dlg_readdata)}  -label {Read Target Data..}
    $base.fra17.014.015 add command   -command {Window show $widget(dlg_debugTkspgmr)
Window raise $widget(dlg_debugTkspgmr)}  -label {Debug Tkspgmr..}
    $base.fra17.014.015 add command  -command {spgmr:write "scope on"} -label {Serial Scope}
    $base.fra17.014.015 add command  -label {Arrange}
    $base.fra17.014.015 add command  -label {Save Layout}
    frame $base.fra18  -borderwidth {2} -height {75} -relief {raised} -width {125}
    button $base.fra18.but19  -command {do_reset $reset_sure} -pady {2} -text {Reset}
    button $base.fra18.but20  -command {do_erase $erase_sure} -pady {2} -text {Erase}
    button $base.fra18.but21  -command {do_program $program_sure} -pady {2} -text {Program}
    frame $base.fra18.fra22  -borderwidth {1} -height {30} -relief {raised} -width {30}
    label $base.fra18.fra22.01  -anchor {e} -relief {groove} -text {Cpu:}
    entry $base.fra18.fra22.02  -background {#f0f0f0} -cursor {}  -font [vTcl:font:get_font "vTcl:font10"] -highlightthickness {0}  -width {6}
    frame $base.fra23  -borderwidth {2} -height {75} -relief {groove} -width {125}
    frame $base.fra23.fra24  -borderwidth {1} -height {30} -relief {raised} -width {30}
    entry $base.fra23.fra24.01  -background {#f0f0f0} -cursor {}  -font [vTcl:font:get_font "vTcl:font10"]  -textvariable {srec_filename}
    button $base.fra23.fra24.02  -command {get_srec_filename} -pady {2} -text {S19 File:}
    frame $base.fra25  -borderwidth {2} -height {75} -relief {groove} -width {125}
    menu $base.m17  -cursor {} -tearoff {0}
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra17  -in $base -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.fra17.01  -in $base.fra17 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra17.03  -in $base.fra17 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra17.08  -in $base.fra17 -anchor {center} -expand {0} -fill {none}  -side {right}
    pack $base.fra17.010  -in $base.fra17 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra17.014  -in $base.fra17 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra18  -in $base -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.fra18.but19  -in $base.fra18 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra18.but20  -in $base.fra18 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra18.but21  -in $base.fra18 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra18.fra22  -in $base.fra18 -anchor {center} -expand {0} -fill {none}  -side {right}
    pack $base.fra18.fra22.01  -in $base.fra18.fra22 -anchor {center} -expand {0} -fill {none}  -padx {2} -pady {2} -side {left}
    pack $base.fra18.fra22.02  -in $base.fra18.fra22 -anchor {center} -expand {1} -fill {x}  -padx {2} -pady {2} -side {right}
    pack $base.fra23  -in $base -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.fra23.fra24  -in $base.fra23 -anchor {center} -expand {0} -fill {x} -side {top}
    pack $base.fra23.fra24.01  -in $base.fra23.fra24 -anchor {center} -expand {1} -fill {x}  -padx {2} -pady {2} -side {right}
    pack $base.fra23.fra24.02  -in $base.fra23.fra24 -anchor {center} -expand {0} -fill {none}  -side {left}
    pack $base.fra25  -in $base -anchor {center} -expand {1} -fill {both} -padx {8}  -pady {8} -side {top}
}

Window show .
Window show .top17

main $argc $argv
